# Class: Arcade

## Phaser.Physics. Arcade

Arcade Physics Constructor

#### new Arcade(game)

  Arcade Physics constructor.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | reference to the current game instance.

  Source:
    - physics/arcade/World.js, line 15

### Classes

Body

### Members

#### bounds

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `bounds` | Phaser.Rectangle | The bounds inside of which the physics world exists. Defaults to match the world bounds.

  Source:
    - physics/arcade/World.js, line 30

#### checkCollision

  Set the checkCollision properties to control for which bounds collision is processed. For example checkCollision.down = false means Bodies cannot collide with the World.bounds.bottom.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `checkCollision` | object | An object containing allowed collision flags.

  Source:
    - physics/arcade/World.js, line 37

#### forceX

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `forceX` | boolean | If true World.separate will always separate on the X axis before Y. Otherwise it will check gravity totals first.

  Source:
    - physics/arcade/World.js, line 62

#### game

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | Local reference to game.

  Source:
    - physics/arcade/World.js, line 20

#### gravity

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `gravity` | Phaser.Point | The World gravity setting. Defaults to x: 0, y: 0, or no gravity.

  Source:
    - physics/arcade/World.js, line 25

#### maxLevels

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `maxLevels` | number | Used by the QuadTree to set the maximum number of iteration levels.

  Source:
    - physics/arcade/World.js, line 47

#### maxObjects

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `maxObjects` | number | Used by the QuadTree to set the maximum number of objects per quad.

  Source:
    - physics/arcade/World.js, line 42

#### OVERLAP_BIAS

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `OVERLAP_BIAS` | number | A value added to the delta values during collision checks.

  Source:
    - physics/arcade/World.js, line 52

#### quadTree

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `quadTree` | Phaser.QuadTree | The world QuadTree.

  Source:
    - physics/arcade/World.js, line 67

#### TILE_BIAS

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `TILE_BIAS` | number | A value added to the delta values during collision with tiles. Adjust this if you get tunnelling.

  Source:
    - physics/arcade/World.js, line 57

### Methods

#### accelerateToObject(displayObject, destination, speed, xSpeedMax, ySpeedMax) → {number}

  Sets the acceleration.x/y property on the display object so it will move towards the target at the given speed (in pixels per second sq.) You must give a maximum speed value, beyond which the display object won't go any faster. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `destination` | any |  |  | The display object to move towards. Can be any object but must have visible x/y properties.
  `speed` | number | <optional> | 60 | The speed it will accelerate in pixels per second.
  `xSpeedMax` | number | <optional> | 500 | The maximum x velocity the display object can reach.
  `ySpeedMax` | number | <optional> | 500 | The maximum y velocity the display object can reach.

  Source:
    - physics/arcade/World.js, line 1531

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new trajectory.

  Type
    number

#### accelerateToPointer(displayObject, pointer, speed, xSpeedMax, ySpeedMax) → {number}

  Sets the acceleration.x/y property on the display object so it will move towards the target at the given speed (in pixels per second sq.) You must give a maximum speed value, beyond which the display object won't go any faster. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `pointer` | Phaser.Pointer | <optional> |  | The pointer to move towards. Defaults to Phaser.Input.activePointer.
  `speed` | number | <optional> | 60 | The speed it will accelerate in pixels per second.
  `xSpeedMax` | number | <optional> | 500 | The maximum x velocity the display object can reach.
  `ySpeedMax` | number | <optional> | 500 | The maximum y velocity the display object can reach.

  Source:
    - physics/arcade/World.js, line 1560

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new trajectory.

  Type
    number

#### accelerateToXY(displayObject, x, y, speed, xSpeedMax, ySpeedMax) → {number}

  Sets the acceleration.x/y property on the display object so it will move towards the x/y coordinates at the given speed (in pixels per second sq.) You must give a maximum speed value, beyond which the display object won't go any faster. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `x` | number |  |  | The x coordinate to accelerate towards.
  `y` | number |  |  | The y coordinate to accelerate towards.
  `speed` | number | <optional> | 60 | The speed it will accelerate in pixels per second.
  `xSpeedMax` | number | <optional> | 500 | The maximum x velocity the display object can reach.
  `ySpeedMax` | number | <optional> | 500 | The maximum y velocity the display object can reach.

  Source:
    - physics/arcade/World.js, line 1590

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new trajectory.

  Type
    number

#### accelerationFromRotation(rotation, speed, point) → {Phaser.Point}

  Given the rotation (in radians) and speed calculate the acceleration and return it as a Point object, or set it to the given point object. One way to use this is: accelerationFromRotation(rotation, 200, sprite.acceleration) which will set the values directly to the sprites acceleration and not create a new Point object.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `rotation` | number |  |  | The angle in radians.
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second sq.
  `point` | Phaser.Point | object | <optional> |  | The Point object in which the x and y properties will be set to the calculated acceleration.

  Source:
    - physics/arcade/World.js, line 1512

  ##### Returns:

  - A Point where point.x contains the acceleration x value and point.y contains the acceleration y value.
  Type
    Phaser.Point

#### angleBetween(source, target) → {number}

  Find the angle in radians between two display objects (like Sprites).

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `source` | any | The Display Object to test from.
  `target` | any | The Display Object to test to.

  Source:
    - physics/arcade/World.js, line 1678

  ##### Returns:

  The angle in radians between the source and target display objects.

  Type
    number

#### angleToPointer(displayObject, pointer) → {number}

  Find the angle in radians between a display object (like a Sprite) and a Pointer, taking their x/y and center into account.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `displayObject` | any |  | The Display Object to test from.
  `pointer` | Phaser.Pointer | <optional> | The Phaser.Pointer to test to. If none is given then Input.activePointer is used.

  Source:
    - physics/arcade/World.js, line 1713

  ##### Returns:

  The angle in radians between displayObject.x/y to Pointer.x/y

  Type
    number

#### angleToXY(displayObject, x, y) → {number}

  Find the angle in radians between a display object (like a Sprite) and the given x/y coordinate.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `displayObject` | any | The Display Object to test from.
  `x` | number | The x coordinate to get the angle to.
  `y` | number | The y coordinate to get the angle to.

  Source:
    - physics/arcade/World.js, line 1695

  ##### Returns:

  The angle in radians between displayObject.x/y to Pointer.x/y

  Type
    number

#### collide(object1, object2, collideCallback, processCallback, callbackContext) → {boolean}

  Checks for collision between two game objects. You can perform Sprite vs. Sprite, Sprite vs. Group, Group vs. Group, Sprite vs. Tilemap Layer or Group vs. Tilemap Layer collisions. The second parameter can be an array of objects, of differing types. The objects are also automatically separated. If you don't require separation then use ArcadePhysics.overlap instead. An optional processCallback can be provided. If given this function will be called when two sprites are found to be colliding. It is called before any separation takes place, giving you the chance to perform additional checks. If the function returns true then the collision and separation is carried out. If it returns false it is skipped. The collideCallback is an optional function that is only called if two sprites collide. If a processCallback has been set then it needs to return true for collideCallback to be called.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `object1` | Phaser.Sprite | Phaser.Group | Phaser.Particles.Emitter | Phaser.Tilemap |  |  | The first object to check. Can be an instance of Phaser.Sprite, Phaser.Group, Phaser.Particles.Emitter, or Phaser.Tilemap.
  `object2` | Phaser.Sprite | Phaser.Group | Phaser.Particles.Emitter | Phaser.Tilemap | array |  |  | The second object or array of objects to check. Can be Phaser.Sprite, Phaser.Group, Phaser.Particles.Emitter or Phaser.Tilemap.
  `collideCallback` | function | <optional> | null | An optional callback function that is called if the objects collide. The two objects will be passed to this function in the same order in which you specified them, unless you are colliding Group vs. Sprite, in which case Sprite will always be the first parameter.
  `processCallback` | function | <optional> | null | A callback function that lets you perform additional checks against the two objects if they overlap. If this is set then collision will only happen if processCallback returns true. The two objects will be passed to this function in the same order in which you specified them.
  `callbackContext` | object | <optional> |  | The context in which to run the callbacks.

  Source:
    - physics/arcade/World.js, line 370

  ##### Returns:

  True if a collision occured otherwise false.

  Type
    boolean

#### computeVelocity(axis, body, velocity, acceleration, drag, max) → {number}

  A tween-like function that takes a starting velocity and some other factors and returns an altered velocity. Based on a function in Flixel by @ADAMATOMIC

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `axis` | number |  |  | 0 for nothing, 1 for horizontal, 2 for vertical.
  `body` | Phaser.Physics.Arcade.Body |  |  | The Body object to be updated.
  `velocity` | number |  |  | Any component of velocity (e.g. 20).
  `acceleration` | number |  |  | Rate at which the velocity is changing.
  `drag` | number |  |  | Really kind of a deceleration, this is how much the velocity changes if Acceleration is not set.
  `max` | number | <optional> | 10000 | An absolute value cap for the velocity.

  Source:
    - physics/arcade/World.js, line 270

  ##### Returns:

  The altered Velocity value.

  Type
    number

#### distanceBetween(source, target) → {number}

  Find the distance between two display objects (like Sprites).

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `source` | any | The Display Object to test from.
  `target` | any | The Display Object to test to.

  Source:
    - physics/arcade/World.js, line 1620

  ##### Returns:

  The distance between the source and target objects.

  Type
    number

#### distanceToPointer(displayObject, pointer) → {number}

  Find the distance between a display object (like a Sprite) and a Pointer. If no Pointer is given the Input.activePointer is used. The calculation is made from the display objects x/y coordinate. This may be the top-left if its anchor hasn't been changed. If you need to calculate from the center of a display object instead use the method distanceBetweenCenters()

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `displayObject` | any |  | The Display Object to test from.
  `pointer` | Phaser.Pointer | <optional> | The Phaser.Pointer to test to. If none is given then Input.activePointer is used.

  Source:
    - physics/arcade/World.js, line 1657

  ##### Returns:

  The distance between the object and the Pointer.

  Type
    number

#### distanceToXY(displayObject, x, y) → {number}

  Find the distance between a display object (like a Sprite) and the given x/y coordinates. The calculation is made from the display objects x/y coordinate. This may be the top-left if its anchor hasn't been changed. If you need to calculate from the center of a display object instead use the method distanceBetweenCenters()

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `displayObject` | any | The Display Object to test from.
  `x` | number | The x coordinate to move towards.
  `y` | number | The y coordinate to move towards.

  Source:
    - physics/arcade/World.js, line 1637

  ##### Returns:

  The distance between the object and the x/y coordinates.

  Type
    number

#### enable(object, children)

  This will create an Arcade Physics body on the given game object or array of game objects. A game object can only have 1 physics body active at any one time, and it can't be changed until the object is destroyed.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `object` | object | array | Phaser.Group |  |  | The game object to create the physics body on. Can also be an array or Group of objects, a body will be created on every child that has a `body` property.
  `children` | boolean | <optional> | true | Should a body be created on all children of this object? If true it will recurse down the display list as far as it can go.

  Source:
    - physics/arcade/World.js, line 181

#### enableBody(object)

  Creates an Arcade Physics body on the given game object. A game object can only have 1 physics body active at any one time, and it can't be changed until the body is nulled.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `object` | object | The game object to create the physics body on. A body will only be created if this object has a null `body` property.

  Source:
    - physics/arcade/World.js, line 237

#### getObjectsUnderPointer(pointer, group, callback, callbackContext) → {array}

  Given a Group and a Pointer this will check to see which Group children overlap with the Pointer coordinates. Each child will be sent to the given callback for further processing. Note that the children are not checked for depth order, but simply if they overlap the Pointer or not.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `pointer` | Phaser.Pointer |  | The Pointer to check.
  `group` | Phaser.Group |  | The Group to check.
  `callback` | function | <optional> | A callback function that is called if the object overlaps with the Pointer. The callback will be sent two parameters: the Pointer and the Object that overlapped with it.
  `callbackContext` | object | <optional> | The context in which to run the callback.

  Source:
    - physics/arcade/World.js, line 1321

  ##### Returns:

  An array of the Sprites from the Group that overlapped the Pointer coordinates.

  Type
    array

#### intersects(body1, body2) → {boolean}

  Check for intersection against two bodies.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `body1` | Phaser.Physics.Arcade.Body | The Body object to check.
  `body2` | Phaser.Physics.Arcade.Body | The Body object to check.

  Source:
    - physics/arcade/World.js, line 776

  ##### Returns:

  True if they intersect, otherwise false.

  Type
    boolean

#### moveToObject(displayObject, destination, speed, maxTime) → {number}

  Move the given display object towards the destination object at a steady velocity. If you specify a maxTime then it will adjust the speed (overwriting what you set) so it arrives at the destination in that number of seconds. Timings are approximate due to the way browser timers work. Allow for a variance of +- 50ms. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates. Note: Doesn't take into account acceleration, maxVelocity or drag (if you've set drag or acceleration too high this object may not move at all)

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `destination` | any |  |  | The display object to move towards. Can be any object but must have visible x/y properties.
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second (default is 60 pixels/sec)
  `maxTime` | number | <optional> | 0 | Time given in milliseconds (1000 = 1 sec). If set the speed is adjusted so the object will arrive at destination in the given number of ms.

  Source:
    - physics/arcade/World.js, line 1368

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new velocity.

  Type
    number

#### moveToPointer(displayObject, speed, pointer, maxTime) → {number}

  Move the given display object towards the pointer at a steady velocity. If no pointer is given it will use Phaser.Input.activePointer. If you specify a maxTime then it will adjust the speed (over-writing what you set) so it arrives at the destination in that number of seconds. Timings are approximate due to the way browser timers work. Allow for a variance of +- 50ms. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second (default is 60 pixels/sec)
  `pointer` | Phaser.Pointer | <optional> |  | The pointer to move towards. Defaults to Phaser.Input.activePointer.
  `maxTime` | number | <optional> | 0 | Time given in milliseconds (1000 = 1 sec). If set the speed is adjusted so the object will arrive at destination in the given number of ms.

  Source:
    - physics/arcade/World.js, line 1403

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new velocity.

  Type
    number

#### moveToXY(displayObject, x, y, speed, maxTime) → {number}

  Move the given display object towards the x/y coordinates at a steady velocity. If you specify a maxTime then it will adjust the speed (over-writing what you set) so it arrives at the destination in that number of seconds. Timings are approximate due to the way browser timers work. Allow for a variance of +- 50ms. Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course. Note: The display object doesn't stop moving once it reaches the destination coordinates. Note: Doesn't take into account acceleration, maxVelocity or drag (if you've set drag or acceleration too high this object may not move at all)

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `displayObject` | any |  |  | The display object to move.
  `x` | number |  |  | The x coordinate to move towards.
  `y` | number |  |  | The y coordinate to move towards.
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second (default is 60 pixels/sec)
  `maxTime` | number | <optional> | 0 | Time given in milliseconds (1000 = 1 sec). If set the speed is adjusted so the object will arrive at destination in the given number of ms.

  Source:
    - physics/arcade/World.js, line 1438

  ##### Returns:

  The angle (in radians) that the object should be visually set to in order to match its new velocity.

  Type
    number

#### overlap(object1, object2, overlapCallback, processCallback, callbackContext) → {boolean}

  Checks for overlaps between two game objects. The objects can be Sprites, Groups or Emitters. You can perform Sprite vs. Sprite, Sprite vs. Group and Group vs. Group overlap checks. Unlike collide the objects are NOT automatically separated or have any physics applied, they merely test for overlap results. The second parameter can be an array of objects, of differing types.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `object1` | Phaser.Sprite | Phaser.Group | Phaser.Particles.Emitter |  |  | The first object to check. Can be an instance of Phaser.Sprite, Phaser.Group or Phaser.Particles.Emitter.
  `object2` | Phaser.Sprite | Phaser.Group | Phaser.Particles.Emitter | array |  |  | The second object or array of objects to check. Can be Phaser.Sprite, Phaser.Group or Phaser.Particles.Emitter.
  `overlapCallback` | function | <optional> | null | An optional callback function that is called if the objects overlap. The two objects will be passed to this function in the same order in which you specified them.
  `processCallback` | function | <optional> | null | A callback function that lets you perform additional checks against the two objects if they overlap. If this is set then overlapCallback will only be called if processCallback returns true.
  `callbackContext` | object | <optional> |  | The context in which to run the callbacks.

  Source:
    - physics/arcade/World.js, line 331

  ##### Returns:

  True if an overlap occured otherwise false.

  Type
    boolean

#### setBounds(x, y, width, height)

  Updates the size of this physics world.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `x` | number | Top left most corner of the world.
  `y` | number | Top left most corner of the world.
  `width` | number | New width of the world. Can never be smaller than the Game.width.
  `height` | number | New height of the world. Can never be smaller than the Game.height.

  Source:
    - physics/arcade/World.js, line 155

#### setBoundsToWorld()

  Updates the size of this physics world to match the size of the game world.

  Source:
    - physics/arcade/World.js, line 170

#### updateMotion(The)

  Called automatically by a Physics body, it updates all motion related values on the Body.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `The` | Phaser.Physics.Arcade.Body | Body object to be updated.

  Source:
    - physics/arcade/World.js, line 253

#### velocityFromAngle(angle, speed, point) → {Phaser.Point}

  Given the angle (in degrees) and speed calculate the velocity and return it as a Point object, or set it to the given point object. One way to use this is: velocityFromAngle(angle, 200, sprite.velocity) which will set the values directly to the sprites velocity and not create a new Point object.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `angle` | number |  |  | The angle in degrees calculated in clockwise positive direction (down = 90 degrees positive, right = 0 degrees positive, up = 90 degrees negative)
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second sq.
  `point` | Phaser.Point | object | <optional> |  | The Point object in which the x and y properties will be set to the calculated velocity.

  Source:
    - physics/arcade/World.js, line 1474

  ##### Returns:

  - A Point where point.x contains the velocity x value and point.y contains the velocity y value.
  Type
    Phaser.Point

#### velocityFromRotation(rotation, speed, point) → {Phaser.Point}

  Given the rotation (in radians) and speed calculate the velocity and return it as a Point object, or set it to the given point object. One way to use this is: velocityFromRotation(rotation, 200, sprite.velocity) which will set the values directly to the sprites velocity and not create a new Point object.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `rotation` | number |  |  | The angle in radians.
  `speed` | number | <optional> | 60 | The speed it will move, in pixels per second sq.
  `point` | Phaser.Point | object | <optional> |  | The Point object in which the x and y properties will be set to the calculated velocity.

  Source:
    - physics/arcade/World.js, line 1493

  ##### Returns:

  - A Point where point.x contains the velocity x value and point.y contains the velocity y value.
  Type
    Phaser.Point